var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
/// <reference path="mwg.d.ts" />
var org;
(function (org) {
    var mwg;
    (function (mwg) {
        var structure;
        (function (structure) {
            var StructurePlugin = (function () {
                function StructurePlugin() {
                }
                StructurePlugin.prototype.start = function (graph) {
                    graph.actionRegistry().declaration(org.mwg.structure.action.NearestNWithinRadius.NAME).setParams(org.mwg.Type.INT, org.mwg.Type.DOUBLE, org.mwg.Type.DOUBLE_ARRAY).setFactory(function (params) {
                        {
                            return new org.mwg.structure.action.NearestNWithinRadius(params[0], params[1], params[2], params[3]);
                        }
                    });
                    graph.nodeRegistry().declaration(org.mwg.structure.trees.KDTree.NAME).setFactory(function (world, time, id, graph) {
                        {
                            return new org.mwg.structure.trees.KDTree(world, time, id, graph);
                        }
                    });
                    graph.nodeRegistry().declaration(org.mwg.structure.trees.NDTree.NAME).setFactory(function (world, time, id, graph) {
                        {
                            return new org.mwg.structure.trees.NDTree(world, time, id, graph);
                        }
                    });
                };
                StructurePlugin.prototype.stop = function () { };
                return StructurePlugin;
            }());
            structure.StructurePlugin = StructurePlugin;
            var action;
            (function (action) {
                var NearestNWithinRadius = (function () {
                    function NearestNWithinRadius(n, radius, key, fetchNodes) {
                        this._key = key;
                        this._n = n;
                        this._radius = radius;
                        this._fetchNodes = fetchNodes;
                    }
                    NearestNWithinRadius.prototype.eval = function (ctx) {
                        var previousResult = ctx.result();
                        var nextResult = ctx.newResult();
                        if (previousResult != null) {
                            var defer_1 = ctx.graph().newCounter(previousResult.size());
                            var previousResultIt = previousResult.iterator();
                            var iter = previousResultIt.next();
                            var _loop_1 = function () {
                                if (iter instanceof org.mwg.structure.trees.NDTree || iter instanceof org.mwg.structure.trees.KDTree) {
                                    var tr_1 = iter.nearestNWithinRadius(this_1._key, this_1._n, this_1._radius);
                                    if (this_1._fetchNodes) {
                                        var nodeIds = new Float64Array(tr_1.size());
                                        for (var i = 0; i < tr_1.size(); i++) {
                                            nodeIds[i] = tr_1.value(i);
                                        }
                                        ctx.graph().lookupAll(ctx.world(), ctx.time(), nodeIds, function (result) {
                                            for (var j = 0; j < result.length; j++) {
                                                var line = ctx.newResult();
                                                line.add(tr_1.keys(j));
                                                line.add(result[j]);
                                                line.add(tr_1.distance(j));
                                                nextResult.add(line);
                                            }
                                            tr_1.free();
                                            defer_1.count();
                                        });
                                    }
                                    else {
                                        for (var i = 0; i < tr_1.size(); i++) {
                                            var line = ctx.newResult();
                                            line.add(tr_1.keys(i));
                                            line.add(tr_1.value(i));
                                            line.add(tr_1.distance(i));
                                            nextResult.add(line);
                                        }
                                        tr_1.free();
                                        defer_1.count();
                                    }
                                }
                                else {
                                    defer_1.count();
                                }
                                iter = previousResultIt.next();
                            };
                            var this_1 = this;
                            while (iter != null) {
                                _loop_1();
                            }
                            defer_1.then(function () {
                                {
                                    ctx.continueWith(nextResult);
                                }
                            });
                        }
                        else {
                            ctx.continueWith(nextResult);
                        }
                    };
                    NearestNWithinRadius.prototype.serialize = function (builder) {
                        throw new Error("Not supported yet!");
                    };
                    NearestNWithinRadius.prototype.toString = function () {
                        return "NearestNWithinRadius(\'" + "\')";
                    };
                    return NearestNWithinRadius;
                }());
                NearestNWithinRadius.NAME = "NearestNWithinRadius";
                action.NearestNWithinRadius = NearestNWithinRadius;
            })(action = structure.action || (structure.action = {}));
            var distance;
            (function (distance_1) {
                var CosineDistance = (function () {
                    function CosineDistance() {
                    }
                    CosineDistance.instance = function () {
                        if (CosineDistance.static_instance == null) {
                            CosineDistance.static_instance = new org.mwg.structure.distance.CosineDistance();
                        }
                        return CosineDistance.static_instance;
                    };
                    CosineDistance.prototype.measure = function (x, y) {
                        var sumTop = 0;
                        var sumOne = 0;
                        var sumTwo = 0;
                        for (var i = 0; i < x.length; i++) {
                            sumTop += x[i] * y[i];
                            sumOne += x[i] * x[i];
                            sumTwo += y[i] * y[i];
                        }
                        var cosSim = sumTop / (Math.sqrt(sumOne) * Math.sqrt(sumTwo));
                        if (cosSim < 0) {
                            cosSim = 0;
                        }
                        return 1 - cosSim;
                    };
                    CosineDistance.prototype.compare = function (x, y) {
                        return x < y;
                    };
                    CosineDistance.prototype.getMinValue = function () {
                        return 0;
                    };
                    CosineDistance.prototype.getMaxValue = function () {
                        return java.lang.Double.MAX_VALUE;
                    };
                    return CosineDistance;
                }());
                CosineDistance.static_instance = null;
                distance_1.CosineDistance = CosineDistance;
                var Distances = (function () {
                    function Distances() {
                    }
                    Distances.getDistance = function (distance) {
                        switch (distance) {
                            case Distances.EUCLIDEAN:
                                return org.mwg.structure.distance.EuclideanDistance.instance();
                            case Distances.GEODISTANCE:
                                return org.mwg.structure.distance.GeoDistance.instance();
                            case Distances.COSINE:
                                return org.mwg.structure.distance.CosineDistance.instance();
                            case Distances.PEARSON:
                                return org.mwg.structure.distance.PearsonDistance.instance();
                        }
                        return org.mwg.structure.distance.Distances.getDistance(Distances.DEFAULT);
                    };
                    return Distances;
                }());
                Distances.EUCLIDEAN = 0;
                Distances.GEODISTANCE = 1;
                Distances.COSINE = 2;
                Distances.PEARSON = 3;
                Distances.DEFAULT = Distances.EUCLIDEAN;
                distance_1.Distances = Distances;
                var EuclideanDistance = (function () {
                    function EuclideanDistance() {
                    }
                    EuclideanDistance.instance = function () {
                        if (EuclideanDistance.static_instance == null) {
                            EuclideanDistance.static_instance = new org.mwg.structure.distance.EuclideanDistance();
                        }
                        return EuclideanDistance.static_instance;
                    };
                    EuclideanDistance.prototype.measure = function (x, y) {
                        var value = 0;
                        for (var i = 0; i < x.length; i++) {
                            value = value + (x[i] - y[i]) * (x[i] - y[i]);
                        }
                        return Math.sqrt(value);
                    };
                    EuclideanDistance.prototype.compare = function (x, y) {
                        return x < y;
                    };
                    EuclideanDistance.prototype.getMinValue = function () {
                        return 0;
                    };
                    EuclideanDistance.prototype.getMaxValue = function () {
                        return java.lang.Double.MAX_VALUE;
                    };
                    return EuclideanDistance;
                }());
                EuclideanDistance.static_instance = null;
                distance_1.EuclideanDistance = EuclideanDistance;
                var GeoDistance = (function () {
                    function GeoDistance() {
                    }
                    GeoDistance.instance = function () {
                        if (GeoDistance.static_instance == null) {
                            GeoDistance.static_instance = new org.mwg.structure.distance.GeoDistance();
                        }
                        return GeoDistance.static_instance;
                    };
                    GeoDistance.prototype.measure = function (x, y) {
                        var earthRadius = 6371000;
                        var dLat = org.mwg.structure.distance.GeoDistance.toRadians(y[0] - x[0]);
                        var dLng = org.mwg.structure.distance.GeoDistance.toRadians(y[1] - x[1]);
                        var a = Math.sin(dLat / 2) * Math.sin(dLat / 2) + Math.cos(org.mwg.structure.distance.GeoDistance.toRadians(x[0])) * Math.cos(org.mwg.structure.distance.GeoDistance.toRadians(y[0])) * Math.sin(dLng / 2) * Math.sin(dLng / 2);
                        var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
                        return earthRadius * c;
                    };
                    GeoDistance.toRadians = function (angledeg) {
                        return angledeg * Math.PI / 180;
                    };
                    GeoDistance.prototype.compare = function (x, y) {
                        return x < y;
                    };
                    GeoDistance.prototype.getMinValue = function () {
                        return 0;
                    };
                    GeoDistance.prototype.getMaxValue = function () {
                        return java.lang.Double.MAX_VALUE;
                    };
                    return GeoDistance;
                }());
                GeoDistance.static_instance = null;
                distance_1.GeoDistance = GeoDistance;
                var PearsonDistance = (function () {
                    function PearsonDistance() {
                    }
                    PearsonDistance.instance = function () {
                        if (PearsonDistance.static_instance == null) {
                            PearsonDistance.static_instance = new org.mwg.structure.distance.PearsonDistance();
                        }
                        return PearsonDistance.static_instance;
                    };
                    PearsonDistance.prototype.measure = function (a, b) {
                        var xy = 0, x = 0, x2 = 0, y = 0, y2 = 0;
                        for (var i = 0; i < a.length; i++) {
                            xy += a[i] * b[i];
                            x += a[i];
                            y += b[i];
                            x2 += a[i] * a[i];
                            y2 += b[i] * b[i];
                        }
                        var n = a.length;
                        return (xy - (x * y) / n) / Math.sqrt((x2 - (x * x) / n) * (y2 - (y * y) / n));
                    };
                    PearsonDistance.prototype.compare = function (x, y) {
                        return Math.abs(x) > Math.abs(y);
                    };
                    PearsonDistance.prototype.getMinValue = function () {
                        return 1;
                    };
                    PearsonDistance.prototype.getMaxValue = function () {
                        return 0;
                    };
                    return PearsonDistance;
                }());
                PearsonDistance.static_instance = null;
                distance_1.PearsonDistance = PearsonDistance;
            })(distance = structure.distance || (structure.distance = {}));
            var trees;
            (function (trees) {
                var IndexStrategy = (function () {
                    function IndexStrategy() {
                    }
                    return IndexStrategy;
                }());
                IndexStrategy.INDEX = 0;
                IndexStrategy.PROFILE = 1;
                IndexStrategy.DEFAULT = IndexStrategy.INDEX;
                trees.IndexStrategy = IndexStrategy;
                var KDTree = (function (_super) {
                    __extends(KDTree, _super);
                    function KDTree(p_world, p_time, p_id, p_graph) {
                        return _super.call(this, p_world, p_time, p_id, p_graph) || this;
                    }
                    KDTree.checkCreateLevels = function (key1, key2, resolutions) {
                        if (resolutions != null) {
                            for (var i = 0; i < key2.length; i++) {
                                if (Math.abs(key1[i] - key2[i]) > resolutions[i]) {
                                    return true;
                                }
                            }
                        }
                        else {
                            for (var i = 0; i < key2.length; i++) {
                                if ((key1[i] != key2[i])) {
                                    return true;
                                }
                            }
                        }
                        return false;
                    };
                    KDTree.rangeSearch = function (lowk, uppk, center, distance, node, lev, dim, nnl) {
                        if (node == null)
                            return;
                        var key = node.getAt(KDTree.E_KEY);
                        if (lowk[lev] <= key[lev]) {
                            org.mwg.structure.trees.KDTree.rangeSearch(lowk, uppk, center, distance, node.getAt(KDTree.E_LEFT), (lev + 1) % dim, dim, nnl);
                        }
                        var j;
                        j = 0;
                        while (j < dim && lowk[j] <= key[j] && uppk[j] >= key[j]) {
                            j++;
                        }
                        if (j == dim) {
                            nnl.insert(key, node.getAt(KDTree.E_VALUE), distance.measure(key, center));
                        }
                        if (uppk[lev] > key[lev]) {
                            org.mwg.structure.trees.KDTree.rangeSearch(lowk, uppk, center, distance, node.getAt(KDTree.E_RIGHT), (lev + 1) % dim, dim, nnl);
                        }
                    };
                    KDTree.reccursiveTraverse = function (node, nnl, distance, target, hr, lev, dim, max_dist_sqd, radius) {
                        if (node == null) {
                            return;
                        }
                        var pivot = node.getAt(KDTree.E_KEY);
                        if (pivot == null) {
                            throw new Error("Key can't be null");
                        }
                        var s = lev % dim;
                        var pivot_to_target = distance.measure(pivot, target);
                        var left_hr = hr;
                        var right_hr = hr.clone();
                        left_hr.max[s] = pivot[s];
                        right_hr.min[s] = pivot[s];
                        var target_in_left = target[s] < pivot[s];
                        var nearer_kd;
                        var nearer_hr;
                        var further_kd;
                        var further_hr;
                        if (target_in_left) {
                            nearer_kd = node.getAt(KDTree.E_LEFT);
                            nearer_hr = left_hr;
                            further_kd = node.getAt(KDTree.E_RIGHT);
                            further_hr = right_hr;
                        }
                        else {
                            nearer_kd = node.getAt(KDTree.E_RIGHT);
                            nearer_hr = right_hr;
                            further_kd = node.getAt(KDTree.E_LEFT);
                            further_hr = left_hr;
                        }
                        org.mwg.structure.trees.KDTree.reccursiveTraverse(nearer_kd, nnl, distance, target, nearer_hr, lev + 1, dim, max_dist_sqd, radius);
                        var dist_sqd;
                        if (!nnl.isCapacityReached()) {
                            dist_sqd = java.lang.Double.MAX_VALUE;
                        }
                        else {
                            dist_sqd = nnl.getWorstDistance();
                        }
                        max_dist_sqd = Math.min(max_dist_sqd, dist_sqd);
                        var closest = further_hr.closest(target);
                        if (distance.measure(closest, target) < max_dist_sqd) {
                            if (pivot_to_target < dist_sqd) {
                                dist_sqd = pivot_to_target;
                                if (radius > 0) {
                                    if (dist_sqd < radius) {
                                        nnl.insert(pivot, node.getAt(KDTree.E_VALUE), dist_sqd);
                                    }
                                }
                                else {
                                    nnl.insert(pivot, node.getAt(KDTree.E_VALUE), dist_sqd);
                                }
                                if (nnl.isCapacityReached()) {
                                    max_dist_sqd = nnl.getWorstDistance();
                                }
                                else {
                                    max_dist_sqd = java.lang.Double.MAX_VALUE;
                                }
                            }
                            org.mwg.structure.trees.KDTree.reccursiveTraverse(further_kd, nnl, distance, target, further_hr, lev + 1, dim, max_dist_sqd, radius);
                        }
                    };
                    KDTree.internalInsert = function (node, key, value, strategyType, lev, resolution) {
                        var pKey = node.getAt(KDTree.E_KEY);
                        if (pKey == null) {
                            pKey = new Float64Array(key.length);
                            java.lang.System.arraycopy(key, 0, pKey, 0, key.length);
                            node.setAt(KDTree.E_KEY, org.mwg.Type.DOUBLE_ARRAY, pKey);
                            node.setAt(KDTree.E_VALUE, org.mwg.Type.LONG, value);
                            if (strategyType == org.mwg.structure.trees.IndexStrategy.PROFILE) {
                                node.setAt(KDTree.E_SUBTREE_VALUES, org.mwg.Type.LONG, value);
                                var sk = new Float64Array(pKey.length);
                                for (var i = 0; i < key.length; i++) {
                                    sk[i] = pKey[i] * value;
                                }
                                node.setAt(KDTree.E_SUM_KEY, org.mwg.Type.DOUBLE_ARRAY, sk);
                            }
                            node.setAt(KDTree.E_SUBTREE_NODES, org.mwg.Type.LONG, 1);
                            return true;
                        }
                        else if (!org.mwg.structure.trees.KDTree.checkCreateLevels(key, pKey, resolution)) {
                            if (strategyType == org.mwg.structure.trees.IndexStrategy.INDEX) {
                                node.setAt(KDTree.E_VALUE, org.mwg.Type.LONG, value);
                            }
                            else if (strategyType == org.mwg.structure.trees.IndexStrategy.PROFILE) {
                                var sk = node.getAt(KDTree.E_SUM_KEY);
                                for (var i = 0; i < pKey.length; i++) {
                                    sk[i] = (sk[i] + key[i] * value);
                                }
                                node.setAt(KDTree.E_SUM_KEY, org.mwg.Type.DOUBLE_ARRAY, sk);
                                node.setAt(KDTree.E_VALUE, org.mwg.Type.LONG, node.getOrCreateAt(KDTree.E_VALUE, org.mwg.Type.LONG) + value);
                                node.setAt(KDTree.E_SUBTREE_VALUES, org.mwg.Type.LONG, node.getOrCreateAt(KDTree.E_SUBTREE_VALUES, org.mwg.Type.LONG) + value);
                            }
                            return false;
                        }
                        else {
                            var child = void 0;
                            if (key[lev] > pKey[lev]) {
                                child = node.getAt(KDTree.E_RIGHT);
                                if (child == null) {
                                    child = org.mwg.structure.trees.KDTree.createNode(node, true);
                                }
                            }
                            else {
                                child = node.getAt(KDTree.E_LEFT);
                                if (child == null) {
                                    child = org.mwg.structure.trees.KDTree.createNode(node, false);
                                }
                            }
                            if (org.mwg.structure.trees.KDTree.internalInsert(child, key, value, strategyType, (lev + 1) % key.length, resolution)) {
                                if (strategyType == org.mwg.structure.trees.IndexStrategy.PROFILE) {
                                    node.setAt(KDTree.E_SUBTREE_VALUES, org.mwg.Type.LONG, node.getAt(KDTree.E_SUBTREE_VALUES) + value);
                                }
                                node.setAt(KDTree.E_SUBTREE_NODES, org.mwg.Type.LONG, node.getAt(KDTree.E_SUBTREE_NODES) + 1);
                                return true;
                            }
                            else {
                                if (strategyType == org.mwg.structure.trees.IndexStrategy.PROFILE) {
                                    node.setAt(KDTree.E_SUBTREE_VALUES, org.mwg.Type.LONG, node.getAt(KDTree.E_SUBTREE_VALUES) + value);
                                }
                                return false;
                            }
                        }
                    };
                    KDTree.createNode = function (parent, right) {
                        var child = parent.graph().newNode();
                        if (right) {
                            parent.setAt(KDTree.E_RIGHT, org.mwg.Type.ENODE, child);
                        }
                        else {
                            parent.setAt(KDTree.E_LEFT, org.mwg.Type.ENODE, child);
                        }
                        return child;
                    };
                    KDTree.prototype.setDistance = function (distanceType) {
                        _super.prototype.set.call(this, KDTree.DISTANCE, org.mwg.Type.INT, distanceType);
                    };
                    KDTree.prototype.insert = function (keys, value) {
                        var state = this.unphasedState();
                        var strategy = org.mwg.structure.trees.IndexStrategy.INDEX;
                        var resolution = state.getFromKey(KDTree.RESOLUTION);
                        var graph = state.getOrCreateFromKey(KDTree.EGRAPH, org.mwg.Type.EGRAPH);
                        {
                            var root = graph.root();
                            if (root == null) {
                                root = graph.newNode();
                                state.setFromKey(KDTree.STRATEGY, org.mwg.Type.INT, strategy);
                                graph.setRoot(root);
                                state.setFromKey(KDTree.DIM, org.mwg.Type.INT, keys.length);
                            }
                            else {
                                if (keys.length != state.getFromKey(KDTree.DIM)) {
                                    throw new Error("Keys should always be the same length");
                                }
                            }
                            org.mwg.structure.trees.KDTree.internalInsert(root, keys, value, strategy, 0, resolution);
                        }
                    };
                    KDTree.prototype.profile = function (keys, occurrence) {
                        var state = this.unphasedState();
                        var strategy = org.mwg.structure.trees.IndexStrategy.PROFILE;
                        var resolution = state.getFromKey(KDTree.RESOLUTION);
                        var graph = state.getOrCreateFromKey(KDTree.EGRAPH, org.mwg.Type.EGRAPH);
                        {
                            var root = graph.root();
                            if (root == null) {
                                root = graph.newNode();
                                state.setFromKey(KDTree.STRATEGY, org.mwg.Type.INT, strategy);
                                graph.setRoot(root);
                                state.setFromKey(KDTree.DIM, org.mwg.Type.INT, keys.length);
                            }
                            else {
                                if (keys.length != state.getFromKey(KDTree.DIM)) {
                                    throw new Error("Keys should always be the same length");
                                }
                            }
                            org.mwg.structure.trees.KDTree.internalInsert(root, keys, occurrence, strategy, 0, resolution);
                        }
                    };
                    KDTree.prototype.nearestN = function (keys, nbElem) {
                        return this.nearestNWithinRadius(keys, -1, -1);
                    };
                    KDTree.prototype.nearestWithinRadius = function (keys, radius) {
                        return this.nearestNWithinRadius(keys, -1, radius);
                    };
                    KDTree.prototype.nearestNWithinRadius = function (keys, nbElem, radius) {
                        var state = this.unphasedState();
                        var graph = state.getOrCreateFromKey(KDTree.EGRAPH, org.mwg.Type.EGRAPH);
                        var distance = org.mwg.structure.distance.Distances.getDistance(state.getFromKeyWithDefault(KDTree.DISTANCE, KDTree.DISTANCE_DEF));
                        {
                            var root = graph.root();
                            if (root == null) {
                                return null;
                            }
                            if (keys.length != root.getAt(KDTree.E_KEY).length) {
                                throw new Error("Keys are not of the same size");
                            }
                            var calcZone = this.graph().space().newVolatileGraph();
                            var nnl = new org.mwg.structure.util.VolatileResult(calcZone.newNode(), nbElem);
                            org.mwg.structure.trees.KDTree.reccursiveTraverse(root, nnl, distance, keys, org.mwg.structure.util.HRect.infiniteHRect(keys.length), 0, keys.length, java.lang.Double.MAX_VALUE, radius);
                            nnl.sort(true);
                            return nnl;
                        }
                    };
                    KDTree.prototype.query = function (min, max) {
                        var state = this.unphasedState();
                        var graph = state.getOrCreateFromKey(KDTree.EGRAPH, org.mwg.Type.EGRAPH);
                        var distance = org.mwg.structure.distance.Distances.getDistance(state.getFromKeyWithDefault(KDTree.DISTANCE, KDTree.DISTANCE_DEF));
                        var center = new Float64Array(max.length);
                        for (var i = 0; i < center.length; i++) {
                            center[i] = (min[i] + max[i]) / 2;
                        }
                        var root = graph.root();
                        if (root == null) {
                            return null;
                        }
                        var calcZone = this.graph().space().newVolatileGraph();
                        var nnl = new org.mwg.structure.util.VolatileResult(calcZone.newNode(), -1);
                        org.mwg.structure.trees.KDTree.rangeSearch(min, max, center, distance, root, 0, min.length, nnl);
                        nnl.sort(true);
                        return nnl;
                    };
                    KDTree.prototype.size = function () {
                        return 0;
                    };
                    KDTree.prototype.numberOfNodes = function () {
                        return 0;
                    };
                    return KDTree;
                }(org.mwg.base.BaseNode));
                KDTree.NAME = "KDTree";
                KDTree.RESOLUTION = "resolution";
                KDTree.DISTANCE = "distance";
                KDTree.EGRAPH = "egraph";
                KDTree.STRATEGY = "strategy";
                KDTree.DIM = "dim";
                KDTree.DISTANCE_DEF = org.mwg.structure.distance.Distances.DEFAULT;
                KDTree.E_SUBTREE_NODES = 0;
                KDTree.E_KEY = 1;
                KDTree.E_SUM_KEY = 2;
                KDTree.E_VALUE = 3;
                KDTree.E_SUBTREE_VALUES = 4;
                KDTree.E_RIGHT = 5;
                KDTree.E_LEFT = 6;
                trees.KDTree = KDTree;
                var NDTree = (function (_super) {
                    __extends(NDTree, _super);
                    function NDTree(p_world, p_time, p_id, p_graph) {
                        return _super.call(this, p_world, p_time, p_id, p_graph) || this;
                    }
                    NDTree.getRelationId = function (centerKey, keyToInsert) {
                        var result = 0;
                        for (var i = 0; i < centerKey.length; i++) {
                            if (i != 0) {
                                result = result << 1;
                            }
                            if (keyToInsert[i] > centerKey[i]) {
                                result += 1;
                            }
                        }
                        return result + NDTree.E_OFFSET_REL;
                    };
                    NDTree.checkCreateLevels = function (min, max, resolutions) {
                        if (resolutions != null) {
                            for (var i = 0; i < min.length; i++) {
                                if ((max[i] - min[i]) > 2 * resolutions[i]) {
                                    return true;
                                }
                            }
                        }
                        else {
                            for (var i = 0; i < min.length; i++) {
                                if ((max[i] > min[i])) {
                                    return true;
                                }
                            }
                        }
                        return false;
                    };
                    NDTree.getCenterMinMax = function (min, max) {
                        var center = new Float64Array(min.length);
                        for (var i = 0; i < min.length; i++) {
                            center[i] = (max[i] + min[i]) / 2;
                        }
                        return center;
                    };
                    NDTree.getCenter = function (node) {
                        var min = node.getAt(NDTree.E_MIN);
                        var max = node.getAt(NDTree.E_MAX);
                        return org.mwg.structure.trees.NDTree.getCenterMinMax(min, max);
                    };
                    NDTree.check = function (values, min, max) {
                        if (min == null || max == null) {
                            throw new Error("Please set min and max boundary before inserting in the trees");
                        }
                        if (values.length != min.length) {
                            throw new Error("Values dimension mismatch");
                        }
                        for (var i = 0; i < min.length; i++) {
                            if (values[i] < min[i] || values[i] > max[i]) {
                                throw new Error("Values should be between min, max!");
                            }
                        }
                    };
                    NDTree.createNewNode = function (parent, root, index, min, max, center, keyToInsert, buffersize) {
                        var node = parent.graph().newNode();
                        var minChild = new Float64Array(min.length);
                        var maxChild = new Float64Array(max.length);
                        for (var i = 0; i < min.length; i++) {
                            if (keyToInsert[i] <= center[i]) {
                                minChild[i] = min[i];
                                maxChild[i] = center[i];
                            }
                            else {
                                minChild[i] = center[i];
                                maxChild[i] = max[i];
                            }
                        }
                        node.setAt(NDTree.E_SUBNODES, org.mwg.Type.LONG, 0);
                        node.setAt(NDTree.E_MIN, org.mwg.Type.DOUBLE_ARRAY, minChild);
                        node.setAt(NDTree.E_MAX, org.mwg.Type.DOUBLE_ARRAY, maxChild);
                        node.setAt(NDTree.E_TOTAL, org.mwg.Type.LONG, 0);
                        root.setAt(NDTree.E_TOTAL_SUBNODES, org.mwg.Type.LONG, root.getAt(NDTree.E_TOTAL_SUBNODES) + 1);
                        parent.setAt(NDTree.E_SUBNODES, org.mwg.Type.LONG, parent.getAt(NDTree.E_SUBNODES) + 1);
                        parent.setAt(index, org.mwg.Type.ENODE, node);
                        return node;
                    };
                    NDTree.subInsert = function (parent, key, value, strategyType, min, max, center, resolution, buffersize, root, bufferupdate) {
                        var index = org.mwg.structure.trees.NDTree.getRelationId(center, key);
                        var child = parent.getAt(index);
                        if (child == null) {
                            child = org.mwg.structure.trees.NDTree.createNewNode(parent, root, index, min, max, center, key, buffersize);
                        }
                        var childmin = child.getAt(NDTree.E_MIN);
                        var childmax = child.getAt(NDTree.E_MAX);
                        var childcenter = org.mwg.structure.trees.NDTree.getCenterMinMax(childmin, childmax);
                        var res = org.mwg.structure.trees.NDTree.internalInsert(child, key, value, strategyType, childmin, childmax, childcenter, resolution, buffersize, root);
                        res = res && !bufferupdate;
                        if (res) {
                            switch (strategyType) {
                                case org.mwg.structure.trees.IndexStrategy.PROFILE: {
                                    parent.setAt(NDTree.E_TOTAL, org.mwg.Type.LONG, parent.getAt(NDTree.E_TOTAL) + value);
                                    break;
                                }
                                case org.mwg.structure.trees.IndexStrategy.INDEX: {
                                    parent.setAt(NDTree.E_TOTAL, org.mwg.Type.LONG, parent.getAt(NDTree.E_TOTAL) + 1);
                                    break;
                                }
                                default:
                                    {
                                        throw new Error("Index strategy is wrong!");
                                    }
                            }
                        }
                        return res;
                    };
                    NDTree.internalInsert = function (node, key, value, strategyType, min, max, center, resolution, buffersize, root) {
                        if (node.getAt(NDTree.E_SUBNODES) != 0) {
                            return org.mwg.structure.trees.NDTree.subInsert(node, key, value, strategyType, min, max, center, resolution, buffersize, root, false);
                        }
                        else if (org.mwg.structure.trees.NDTree.checkCreateLevels(min, max, resolution)) {
                            var buffer = null;
                            if (buffersize > 0) {
                                buffer = node.getOrCreateAt(NDTree.E_BUFFER_KEYS, org.mwg.Type.DMATRIX);
                            }
                            if (buffer != null) {
                                for (var i = 0; i < buffer.columns(); i++) {
                                    if (org.mwg.structure.trees.NDTree.compare(key, buffer.column(i), resolution)) {
                                        switch (strategyType) {
                                            case org.mwg.structure.trees.IndexStrategy.PROFILE: {
                                                var bufferkeys = node.getAt(NDTree.E_PROFILE);
                                                for (var j = 0; j < key.length; j++) {
                                                    bufferkeys.set(j, i, bufferkeys.get(j, i) + key[j] * value);
                                                }
                                                var bufferValue = node.getAt(NDTree.E_BUFFER_VALUES);
                                                bufferValue.set(0, i, bufferValue.get(0, i) + value);
                                                node.setAt(NDTree.E_TOTAL, org.mwg.Type.LONG, node.getAt(NDTree.E_TOTAL) + value);
                                                return true;
                                            }
                                            case org.mwg.structure.trees.IndexStrategy.INDEX: {
                                                var bufferValue = node.getAt(NDTree.E_BUFFER_VALUES);
                                                bufferValue.set(0, i, value);
                                                return false;
                                            }
                                            default:
                                                {
                                                    throw new Error("Index strategy is wrong!");
                                                }
                                        }
                                    }
                                }
                                if (buffer.columns() < buffersize) {
                                    buffer.appendColumn(key);
                                    switch (strategyType) {
                                        case org.mwg.structure.trees.IndexStrategy.PROFILE: {
                                            var bufferkeys = node.getOrCreateAt(NDTree.E_PROFILE, org.mwg.Type.DMATRIX);
                                            bufferkeys.appendColumn(key);
                                            var bufferValue = node.getOrCreateAt(NDTree.E_BUFFER_VALUES, org.mwg.Type.LMATRIX);
                                            bufferValue.appendColumn(new Float64Array([value]));
                                            node.setAt(NDTree.E_TOTAL, org.mwg.Type.LONG, node.getAt(NDTree.E_TOTAL) + value);
                                            return true;
                                        }
                                        case org.mwg.structure.trees.IndexStrategy.INDEX: {
                                            var bufferValue = node.getOrCreateAt(NDTree.E_BUFFER_VALUES, org.mwg.Type.LMATRIX);
                                            bufferValue.appendColumn(new Float64Array([value]));
                                            node.setAt(NDTree.E_TOTAL, org.mwg.Type.LONG, node.getAt(NDTree.E_TOTAL) + 1);
                                            return true;
                                        }
                                        default:
                                            {
                                                throw new Error("Index strategy is wrong!");
                                            }
                                    }
                                }
                                else {
                                    if (strategyType == org.mwg.structure.trees.IndexStrategy.PROFILE) {
                                        var bufferkeys = node.getAt(NDTree.E_PROFILE);
                                        var bufferValue_1 = node.getAt(NDTree.E_BUFFER_VALUES);
                                        for (var i = 0; i < buffer.columns(); i++) {
                                            var t = bufferValue_1.get(0, i);
                                            for (var j = 0; j < buffer.rows(); j++) {
                                                buffer.set(j, i, bufferkeys.get(j, i) / t);
                                            }
                                        }
                                        node.setAt(NDTree.E_PROFILE, org.mwg.Type.DMATRIX, null);
                                    }
                                    var bufferValue = node.getAt(NDTree.E_BUFFER_VALUES);
                                    for (var i = 0; i < buffer.columns(); i++) {
                                        org.mwg.structure.trees.NDTree.subInsert(node, buffer.column(i), bufferValue.get(0, i), strategyType, min, max, center, resolution, buffersize, root, true);
                                    }
                                    node.setAt(NDTree.E_BUFFER_VALUES, org.mwg.Type.LMATRIX, null);
                                    node.setAt(NDTree.E_BUFFER_KEYS, org.mwg.Type.DMATRIX, null);
                                    return org.mwg.structure.trees.NDTree.subInsert(node, key, value, strategyType, min, max, center, resolution, buffersize, root, false);
                                }
                            }
                            else {
                                return org.mwg.structure.trees.NDTree.subInsert(node, key, value, strategyType, min, max, center, resolution, buffersize, root, false);
                            }
                        }
                        else {
                            switch (strategyType) {
                                case org.mwg.structure.trees.IndexStrategy.PROFILE: {
                                    var profile = node.getAt(NDTree.E_PROFILE);
                                    if (profile == null) {
                                        profile = new Float64Array(key.length);
                                        java.lang.System.arraycopy(key, 0, profile, 0, key.length);
                                    }
                                    else {
                                        for (var i = 0; i < key.length; i++) {
                                            profile[i] += key[i] * value;
                                        }
                                    }
                                    node.setAt(NDTree.E_PROFILE, org.mwg.Type.DOUBLE_ARRAY, profile);
                                    node.setAt(NDTree.E_TOTAL, org.mwg.Type.LONG, node.getAt(NDTree.E_TOTAL) + value);
                                    return true;
                                }
                                case org.mwg.structure.trees.IndexStrategy.INDEX: {
                                    if (node.getAt(NDTree.E_TOTAL) == 0) {
                                        node.setAt(NDTree.E_PROFILE, org.mwg.Type.DOUBLE_ARRAY, key);
                                        node.setAt(NDTree.E_VALUE, org.mwg.Type.LONG, value);
                                        node.setAt(NDTree.E_TOTAL, org.mwg.Type.LONG, 1);
                                        return true;
                                    }
                                    else {
                                        node.setAt(NDTree.E_PROFILE, org.mwg.Type.DOUBLE_ARRAY, key);
                                        node.setAt(NDTree.E_VALUE, org.mwg.Type.LONG, value);
                                        return false;
                                    }
                                }
                                default:
                                    {
                                        throw new Error("Index strategy is wrong!");
                                    }
                            }
                        }
                    };
                    NDTree.compare = function (key1, key2, resolution) {
                        if (resolution != null) {
                            for (var i = 0; i < key1.length; i++) {
                                if (Math.abs(key1[i] - key2[i]) > resolution[i]) {
                                    return false;
                                }
                            }
                        }
                        else {
                            for (var i = 0; i < key1.length; i++) {
                                if (Math.abs(key1[i] - key2[i]) > 0) {
                                    return false;
                                }
                            }
                        }
                        return true;
                    };
                    NDTree.prototype.setDistance = function (distanceType) {
                        _super.prototype.set.call(this, NDTree.DISTANCE, org.mwg.Type.INT, distanceType);
                    };
                    NDTree.prototype.insert = function (keys, value) {
                        var state = this.unphasedState();
                        var min = state.getFromKey(NDTree.BOUND_MIN);
                        var max = state.getFromKey(NDTree.BOUND_MAX);
                        org.mwg.structure.trees.NDTree.check(keys, min, max);
                        var resolution = state.getFromKey(NDTree.RESOLUTION);
                        var graph = state.getOrCreateFromKey(NDTree.EGRAPH, org.mwg.Type.EGRAPH);
                        var buffersize = state.getFromKeyWithDefault(NDTree.BUFFER_SIZE, NDTree.BUFFER_SIZE_DEF);
                        {
                            var root = graph.root();
                            if (root == null) {
                                root = graph.newNode();
                                state.setFromKey(NDTree.STRATEGY, org.mwg.Type.INT, org.mwg.structure.trees.IndexStrategy.INDEX);
                                graph.setRoot(root);
                                root.setAt(NDTree.E_TOTAL, org.mwg.Type.LONG, 0);
                                root.setAt(NDTree.E_TOTAL_SUBNODES, org.mwg.Type.LONG, 0);
                                root.setAt(NDTree.E_SUBNODES, org.mwg.Type.LONG, 0);
                                root.setAt(NDTree.E_MIN, org.mwg.Type.DOUBLE_ARRAY, min);
                                root.setAt(NDTree.E_MAX, org.mwg.Type.DOUBLE_ARRAY, max);
                            }
                            org.mwg.structure.trees.NDTree.internalInsert(root, keys, value, org.mwg.structure.trees.IndexStrategy.INDEX, min, max, org.mwg.structure.trees.NDTree.getCenterMinMax(min, max), resolution, buffersize, root);
                        }
                    };
                    NDTree.prototype.profile = function (keys, occurrence) {
                        var state = this.unphasedState();
                        var min = state.getFromKey(NDTree.BOUND_MIN);
                        var max = state.getFromKey(NDTree.BOUND_MAX);
                        org.mwg.structure.trees.NDTree.check(keys, min, max);
                        var resolution = state.getFromKey(NDTree.RESOLUTION);
                        var graph = state.getOrCreateFromKey(NDTree.EGRAPH, org.mwg.Type.EGRAPH);
                        var buffersize = state.getFromKeyWithDefault(NDTree.BUFFER_SIZE, NDTree.BUFFER_SIZE_DEF);
                        {
                            var root = graph.root();
                            if (root == null) {
                                root = graph.newNode();
                                state.setFromKey(NDTree.STRATEGY, org.mwg.Type.INT, org.mwg.structure.trees.IndexStrategy.PROFILE);
                                graph.setRoot(root);
                                root.setAt(NDTree.E_TOTAL, org.mwg.Type.LONG, 0);
                                root.setAt(NDTree.E_TOTAL_SUBNODES, org.mwg.Type.LONG, 0);
                                root.setAt(NDTree.E_SUBNODES, org.mwg.Type.LONG, 0);
                                root.setAt(NDTree.E_MIN, org.mwg.Type.DOUBLE_ARRAY, min);
                                root.setAt(NDTree.E_MAX, org.mwg.Type.DOUBLE_ARRAY, max);
                            }
                            org.mwg.structure.trees.NDTree.internalInsert(root, keys, occurrence, org.mwg.structure.trees.IndexStrategy.PROFILE, min, max, org.mwg.structure.trees.NDTree.getCenterMinMax(min, max), resolution, buffersize, root);
                        }
                    };
                    NDTree.prototype.nearestN = function (keys, nbElem) {
                        return this.nearestNWithinRadius(keys, -1, -1);
                    };
                    NDTree.prototype.nearestWithinRadius = function (keys, radius) {
                        return this.nearestNWithinRadius(keys, -1, radius);
                    };
                    NDTree.prototype.nearestNWithinRadius = function (keys, nbElem, radius) {
                        var state = this.unphasedState();
                        var min = state.getFromKey(NDTree.BOUND_MIN);
                        var max = state.getFromKey(NDTree.BOUND_MAX);
                        org.mwg.structure.trees.NDTree.check(keys, min, max);
                        var graph = state.getOrCreateFromKey(NDTree.EGRAPH, org.mwg.Type.EGRAPH);
                        var distance = org.mwg.structure.distance.Distances.getDistance(state.getFromKeyWithDefault(NDTree.DISTANCE, NDTree.DISTANCE_DEF));
                        var strategyType = state.getFromKey(NDTree.STRATEGY);
                        var root = graph.root();
                        if (root == null) {
                            return null;
                        }
                        var calcZone = this.graph().space().newVolatileGraph();
                        var nnl = new org.mwg.structure.util.VolatileResult(calcZone.newNode(), nbElem);
                        org.mwg.structure.trees.NDTree.reccursiveTraverse(root, calcZone, nnl, strategyType, distance, keys, null, null, null, radius);
                        nnl.sort(true);
                        return nnl;
                    };
                    NDTree.prototype.query = function (min, max) {
                        var state = this.unphasedState();
                        var graph = state.getOrCreateFromKey(NDTree.EGRAPH, org.mwg.Type.EGRAPH);
                        var distance = org.mwg.structure.distance.Distances.getDistance(state.getFromKeyWithDefault(NDTree.DISTANCE, NDTree.DISTANCE_DEF));
                        var strategyType = state.getFromKey(NDTree.STRATEGY);
                        var center = new Float64Array(max.length);
                        for (var i = 0; i < center.length; i++) {
                            center[i] = (min[i] + max[i]) / 2;
                        }
                        var root = graph.root();
                        if (root == null) {
                            return null;
                        }
                        var calcZone = this.graph().space().newVolatileGraph();
                        var nnl = new org.mwg.structure.util.VolatileResult(calcZone.newNode(), -1);
                        org.mwg.structure.trees.NDTree.reccursiveTraverse(root, calcZone, nnl, strategyType, distance, null, min, max, center, -1);
                        nnl.sort(true);
                        return nnl;
                    };
                    NDTree.prototype.size = function () {
                        var state = this.unphasedState();
                        var graph = state.getOrCreateFromKey(NDTree.EGRAPH, org.mwg.Type.EGRAPH);
                        var root = graph.root();
                        if (root == null) {
                            return 0;
                        }
                        else {
                            return root.getAt(NDTree.E_TOTAL);
                        }
                    };
                    NDTree.prototype.numberOfNodes = function () {
                        var state = this.unphasedState();
                        var graph = state.getOrCreateFromKey(NDTree.EGRAPH, org.mwg.Type.EGRAPH);
                        var root = graph.root();
                        if (root == null) {
                            return 0;
                        }
                        else {
                            return root.getAt(NDTree.E_TOTAL_SUBNODES);
                        }
                    };
                    NDTree.binaryFromLong = function (value, dim) {
                        var tempvalue = value - NDTree.E_OFFSET_REL;
                        var shiftvalue = tempvalue >> 1;
                        var res = [];
                        for (var i = 0; i < dim; i++) {
                            res[dim - i - 1] = ((tempvalue - (shiftvalue << 1)) == 1);
                            tempvalue = shiftvalue;
                            shiftvalue = tempvalue >> 1;
                        }
                        return res;
                    };
                    NDTree.reccursiveTraverse = function (node, calcZone, nnl, strategyType, distance, target, targetmin, targetmax, targetcenter, radius) {
                        if (node.getAt(NDTree.E_SUBNODES) == 0) {
                            var buffer = node.getAt(NDTree.E_BUFFER_KEYS);
                            var bufferValue = node.getAt(NDTree.E_BUFFER_VALUES);
                            if (buffer != null) {
                                switch (strategyType) {
                                    case org.mwg.structure.trees.IndexStrategy.PROFILE: {
                                        var tempK = new Float64Array(target.length);
                                        var bufferkeys = node.getAt(NDTree.E_PROFILE);
                                        for (var i = 0; i < buffer.columns(); i++) {
                                            var t = bufferValue.get(0, i);
                                            for (var j = 0; j < buffer.rows(); j++) {
                                                tempK[j] = bufferkeys.get(j, i) / t;
                                            }
                                            org.mwg.structure.util.TreeHelper.filterAndInsert(tempK, t, target, targetmin, targetmax, targetcenter, distance, radius, nnl);
                                        }
                                        return;
                                    }
                                    case org.mwg.structure.trees.IndexStrategy.INDEX: {
                                        for (var i = 0; i < buffer.columns(); i++) {
                                            org.mwg.structure.util.TreeHelper.filterAndInsert(buffer.column(i), bufferValue.get(0, i), target, targetmin, targetmax, targetcenter, distance, radius, nnl);
                                        }
                                        return;
                                    }
                                    default:
                                        {
                                            throw new Error("Index strategy is wrong!");
                                        }
                                }
                            }
                            else {
                                switch (strategyType) {
                                    case org.mwg.structure.trees.IndexStrategy.PROFILE: {
                                        var keyo = node.getAt(NDTree.E_PROFILE);
                                        var key = new Float64Array(keyo.length);
                                        var value = node.getAt(NDTree.E_TOTAL);
                                        for (var i = 0; i < keyo.length; i++) {
                                            key[i] = keyo[i] / value;
                                        }
                                        org.mwg.structure.util.TreeHelper.filterAndInsert(key, value, target, targetmin, targetmax, targetcenter, distance, radius, nnl);
                                        return;
                                    }
                                    case org.mwg.structure.trees.IndexStrategy.INDEX: {
                                        var key = node.getAt(NDTree.E_PROFILE);
                                        var value = node.getAt(NDTree.E_VALUE);
                                        org.mwg.structure.util.TreeHelper.filterAndInsert(key, value, target, targetmin, targetmax, targetcenter, distance, radius, nnl);
                                        return;
                                    }
                                    default:
                                        {
                                            throw new Error("Index strategy is wrong!");
                                        }
                                }
                            }
                        }
                        else {
                            var boundMax_1 = node.getAt(NDTree.E_MAX);
                            var boundMin_1 = node.getAt(NDTree.E_MIN);
                            var worst = nnl.getWorstDistance();
                            if (targetmin == null || targetmax == null) {
                                if (!nnl.isCapacityReached() || org.mwg.structure.util.TreeHelper.getclosestDistance(target, boundMin_1, boundMax_1, distance) <= worst) {
                                    var tempList = calcZone.newNode();
                                    var childPriority_1 = new org.mwg.structure.util.VolatileResult(tempList, -1);
                                    var dim_1 = boundMax_1.length;
                                    var childMin_1 = new Float64Array(dim_1);
                                    var childMax_1 = new Float64Array(dim_1);
                                    node.each(function (attributeKey, elemType, elem) {
                                        {
                                            if (attributeKey >= org.mwg.structure.trees.NDTree.E_OFFSET_REL) {
                                                var binaries = org.mwg.structure.trees.NDTree.binaryFromLong(attributeKey, dim_1);
                                                for (var i = 0; i < dim_1; i++) {
                                                    if (!binaries[i]) {
                                                        childMin_1[i] = boundMin_1[i];
                                                        childMax_1[i] = (boundMax_1[i] + boundMin_1[i]) / 2;
                                                    }
                                                    else {
                                                        childMin_1[i] = (boundMax_1[i] + boundMin_1[i]) / 2;
                                                        childMax_1[i] = boundMax_1[i];
                                                    }
                                                }
                                                childPriority_1.insert(childMin_1, attributeKey, org.mwg.structure.util.TreeHelper.getclosestDistance(target, childMin_1, childMax_1, distance));
                                            }
                                        }
                                    });
                                    childPriority_1.sort(true);
                                    for (var i = 0; i < childPriority_1.size(); i++) {
                                        var child = node.getAt(childPriority_1.value(i));
                                        org.mwg.structure.trees.NDTree.reccursiveTraverse(child, calcZone, nnl, strategyType, distance, target, targetmin, targetmax, targetcenter, radius);
                                    }
                                    childPriority_1.free();
                                }
                            }
                            else {
                                node.each(function (attributeKey, elemType, elem) {
                                    {
                                        if (attributeKey >= org.mwg.structure.trees.NDTree.E_OFFSET_REL) {
                                            var child = node.getAt(attributeKey);
                                            if (org.mwg.structure.util.TreeHelper.checkBoundsIntersection(targetmin, targetmax, child.getAt(org.mwg.structure.trees.NDTree.E_MIN), child.getAt(org.mwg.structure.trees.NDTree.E_MAX))) {
                                                org.mwg.structure.trees.NDTree.reccursiveTraverse(child, calcZone, nnl, strategyType, distance, target, targetmin, targetmax, targetcenter, radius);
                                            }
                                        }
                                    }
                                });
                            }
                        }
                    };
                    return NDTree;
                }(org.mwg.base.BaseNode));
                NDTree.NAME = "NDTree";
                NDTree.BOUND_MIN = "bound_min";
                NDTree.BOUND_MAX = "bound_max";
                NDTree.RESOLUTION = "resolution";
                NDTree.BUFFER_SIZE = "buffer_size";
                NDTree.DISTANCE = "distance";
                NDTree.EGRAPH = "egraph";
                NDTree.STRATEGY = "strategy";
                NDTree.BUFFER_SIZE_DEF = 20;
                NDTree.DISTANCE_DEF = org.mwg.structure.distance.Distances.DEFAULT;
                NDTree.E_TOTAL = 0;
                NDTree.E_SUBNODES = 1;
                NDTree.E_TOTAL_SUBNODES = 2;
                NDTree.E_MIN = 3;
                NDTree.E_MAX = 4;
                NDTree.E_BUFFER_KEYS = 5;
                NDTree.E_BUFFER_VALUES = 6;
                NDTree.E_VALUE = 7;
                NDTree.E_PROFILE = 8;
                NDTree.E_OFFSET_REL = 16;
                trees.NDTree = NDTree;
            })(trees = structure.trees || (structure.trees = {}));
            var util;
            (function (util) {
                var HRect = (function () {
                    function HRect(vmin, vmax) {
                        this.min = new Float64Array(vmin.length);
                        this.max = new Float64Array(vmax.length);
                        java.lang.System.arraycopy(vmin, 0, this.min, 0, vmin.length);
                        java.lang.System.arraycopy(vmax, 0, this.max, 0, vmax.length);
                    }
                    HRect.prototype.clone = function () {
                        return new org.mwg.structure.util.HRect(this.min, this.max);
                    };
                    HRect.prototype.closest = function (t) {
                        var p = new Float64Array(t.length);
                        for (var i = 0; i < t.length; ++i) {
                            if (t[i] <= this.min[i]) {
                                p[i] = this.min[i];
                            }
                            else if (t[i] >= this.max[i]) {
                                p[i] = this.max[i];
                            }
                            else {
                                p[i] = t[i];
                            }
                        }
                        return p;
                    };
                    HRect.infiniteHRect = function (d) {
                        var vmin = new Float64Array(d);
                        var vmax = new Float64Array(d);
                        for (var i = 0; i < d; ++i) {
                            vmin[i] = java.lang.Double.NEGATIVE_INFINITY;
                            vmax[i] = java.lang.Double.POSITIVE_INFINITY;
                        }
                        return new org.mwg.structure.util.HRect(vmin, vmax);
                    };
                    HRect.prototype.toString = function () {
                        return this.min + "\n" + this.max + "\n";
                    };
                    return HRect;
                }());
                util.HRect = HRect;
                var TreeHelper = (function () {
                    function TreeHelper() {
                    }
                    TreeHelper.checkBoundsIntersection = function (targetmin, targetmax, boundMin, boundMax) {
                        for (var i = 0; i < boundMax.length; i++) {
                            if (targetmin[i] > boundMax[i] || targetmax[i] < boundMin[i]) {
                                return false;
                            }
                        }
                        return true;
                    };
                    TreeHelper.checkKeyInsideBounds = function (key, boundMin, boundMax) {
                        for (var i = 0; i < boundMax.length; i++) {
                            if (key[i] > boundMax[i] || key[i] < boundMin[i]) {
                                return false;
                            }
                        }
                        return true;
                    };
                    TreeHelper.getclosestDistance = function (target, boundMin, boundMax, distance) {
                        var closest = new Float64Array(target.length);
                        for (var i = 0; i < target.length; i++) {
                            if (target[i] >= boundMax[i]) {
                                closest[i] = boundMax[i];
                            }
                            else if (target[i] <= boundMin[i]) {
                                closest[i] = boundMin[i];
                            }
                            else {
                                closest[i] = target[i];
                            }
                        }
                        return distance.measure(closest, target);
                    };
                    TreeHelper.filterAndInsert = function (key, value, target, targetmin, targetmax, targetcenter, distance, radius, nnl) {
                        if (targetmin != null) {
                            if (org.mwg.structure.util.TreeHelper.checkKeyInsideBounds(key, targetmin, targetmax)) {
                                nnl.insert(key, value, distance.measure(key, targetcenter));
                            }
                        }
                        else {
                            var dist = distance.measure(key, target);
                            if (radius > 0) {
                                if (dist < radius) {
                                    nnl.insert(key, value, dist);
                                }
                            }
                            else {
                                nnl.insert(key, value, dist);
                            }
                        }
                    };
                    return TreeHelper;
                }());
                util.TreeHelper = TreeHelper;
                var VolatileResult = (function () {
                    function VolatileResult(node, capacity) {
                        this.node = node;
                        this.count = 0;
                        this._keys = node.getOrCreateAt(VolatileResult._KEYS, org.mwg.Type.DMATRIX);
                        this._values = node.getOrCreateAt(VolatileResult._VALUES, org.mwg.Type.LMATRIX);
                        this._distances = node.getOrCreateAt(VolatileResult._DISTANCES, org.mwg.Type.DMATRIX);
                        this.capacity = capacity;
                    }
                    VolatileResult.prototype.size = function () {
                        return this.count;
                    };
                    VolatileResult.prototype.insert = function (key, value, distance) {
                        if (this.capacity > 0 && this.count == this.capacity) {
                            this.add(key, value, distance, true);
                            return true;
                        }
                        this.add(key, value, distance, false);
                        return true;
                    };
                    VolatileResult.prototype.add = function (key, value, distance, remove) {
                        if (this.count == 0) {
                            this._keys.appendColumn(new Float64Array(key.length));
                            this._values.appendColumn(new Float64Array(1));
                            this._distances.appendColumn(new Float64Array([VolatileResult.maxPriority]));
                        }
                        if (remove) {
                            if (distance > this.getWorstDistance()) {
                                return;
                            }
                            this.remove();
                            this.count++;
                            for (var i = 0; i < this._keys.rows(); i++) {
                                this._keys.set(i, this.count, key[i]);
                            }
                            this._values.set(0, this.count, value);
                            this._distances.set(0, this.count, distance);
                        }
                        else {
                            this.count++;
                            this._keys.appendColumn(key);
                            this._values.appendColumn(new Float64Array([value]));
                            this._distances.appendColumn(new Float64Array([distance]));
                        }
                        this.bubbleUp(this.count);
                        this.worst = this._distances.get(0, 1);
                    };
                    VolatileResult.prototype.remove = function () {
                        if (this.count == 0)
                            return;
                        for (var i = 0; i < this._keys.rows(); i++) {
                            this._keys.set(i, 1, this._keys.get(i, this.count));
                            this._keys.set(i, this.count, 0);
                        }
                        this._values.set(0, 1, this._values.get(0, this.count));
                        this._distances.set(0, 1, this._distances.get(0, this.count));
                        this._values.set(0, this.count, 0);
                        this._distances.set(0, this.count, 0);
                        this.count--;
                        this.bubbleDown(1);
                    };
                    VolatileResult.prototype.bubbleUp = function (pos) {
                        var okey = this._keys.column(pos);
                        var element = this._values.column(pos)[0];
                        var priority = this._distances.column(pos)[0];
                        var halfpos = Math.floor(pos / 2);
                        while (this._distances.column(halfpos)[0] < priority) {
                            this._distances.set(0, pos, this._distances.get(0, halfpos));
                            this._values.set(0, pos, this._values.get(0, halfpos));
                            for (var i = 0; i < this._keys.rows(); i++) {
                                this._keys.set(i, pos, this._keys.get(i, halfpos));
                            }
                            pos = Math.floor(pos / 2);
                            halfpos = Math.floor(pos / 2);
                        }
                        this._distances.set(0, pos, priority);
                        this._values.set(0, pos, element);
                        for (var i = 0; i < this._keys.rows(); i++) {
                            this._keys.set(i, pos, okey[i]);
                        }
                    };
                    VolatileResult.prototype.bubbleDown = function (pos) {
                        var okey = this._keys.column(pos);
                        var element = this._values.column(pos)[0];
                        var priority = this._distances.column(pos)[0];
                        var child;
                        for (; pos * 2 <= this.count; pos = child) {
                            child = pos * 2;
                            if (child != this.count)
                                if (this._distances.get(0, child) < this._distances.get(0, child + 1))
                                    child++;
                            if (priority < this._distances.get(0, child)) {
                                this._distances.set(0, pos, this._distances.get(0, child));
                                this._values.set(0, pos, this._values.get(0, child));
                                for (var i = 0; i < this._keys.rows(); i++) {
                                    this._keys.set(i, pos, this._keys.get(i, child));
                                }
                            }
                            else {
                                break;
                            }
                        }
                        this._distances.set(0, pos, priority);
                        this._values.set(0, pos, element);
                        for (var i = 0; i < this._keys.rows(); i++) {
                            this._keys.set(i, pos, okey[i]);
                        }
                    };
                    VolatileResult.prototype.keys = function (index) {
                        return this._keys.column(index + 1);
                    };
                    VolatileResult.prototype.value = function (index) {
                        return this._values.get(index + 1, 0);
                    };
                    VolatileResult.prototype.distance = function (index) {
                        return this._distances.get(index + 1, 0);
                    };
                    VolatileResult.prototype.getWorstDistance = function () {
                        if (this.count == 0) {
                            return java.lang.Double.POSITIVE_INFINITY;
                        }
                        return this.worst;
                    };
                    VolatileResult.prototype.free = function () {
                        var g = this.node.graph();
                        this.node.drop();
                        if (g.size() == 0) {
                            g.free();
                        }
                    };
                    VolatileResult.prototype.isCapacityReached = function () {
                        return this.capacity > 0 && (this.count == this.capacity);
                    };
                    VolatileResult.prototype.swap = function (i, j) {
                        var tempkey = this._keys.column(i);
                        var tempvalue = this._values.get(0, i);
                        var tempdist = this._distances.get(0, i);
                        this._distances.set(0, i, this._distances.get(0, j));
                        this._values.set(0, i, this._values.get(0, j));
                        for (var k = 0; k < this._keys.rows(); k++) {
                            this._keys.set(k, i, this._keys.get(k, j));
                        }
                        this._distances.set(0, j, tempdist);
                        this._values.set(0, j, tempvalue);
                        for (var k = 0; k < this._keys.rows(); k++) {
                            this._keys.set(k, j, tempkey[k]);
                        }
                    };
                    VolatileResult.prototype.partition = function (l, h, ascending) {
                        var x = this._distances.get(0, h);
                        var i = (l - 1);
                        for (var j = l; j <= h - 1; j++) {
                            if (ascending) {
                                if (this._distances.get(0, j) <= x) {
                                    i++;
                                    this.swap(i, j);
                                }
                            }
                            else {
                                if (this._distances.get(0, j) > x) {
                                    i++;
                                    this.swap(i, j);
                                }
                            }
                        }
                        this.swap(i + 1, h);
                        return (i + 1);
                    };
                    VolatileResult.prototype.quickSort = function (l, h, ascending) {
                        var stack = new Int32Array(h - l + 1);
                        var top = -1;
                        stack[++top] = l;
                        stack[++top] = h;
                        while (top >= 0) {
                            h = stack[top--];
                            l = stack[top--];
                            var p = this.partition(l, h, ascending);
                            if (p - 1 > l) {
                                stack[++top] = l;
                                stack[++top] = p - 1;
                            }
                            if (p + 1 < h) {
                                stack[++top] = p + 1;
                                stack[++top] = h;
                            }
                        }
                    };
                    VolatileResult.prototype.sort = function (ascending) {
                        if (this.count > 1) {
                            this.quickSort(1, this.count, ascending);
                        }
                    };
                    return VolatileResult;
                }());
                VolatileResult.maxPriority = java.lang.Double.MAX_VALUE;
                VolatileResult._KEYS = 1;
                VolatileResult._VALUES = 2;
                VolatileResult._DISTANCES = 3;
                util.VolatileResult = VolatileResult;
            })(util = structure.util || (structure.util = {}));
        })(structure = mwg.structure || (mwg.structure = {}));
    })(mwg = org.mwg || (org.mwg = {}));
})(org || (org = {}));
//# sourceMappingURL=mwg.structure.js.map